'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2;

var _rax = require('rax');

var _View = require('./View');

var _View2 = _interopRequireDefault(_View);

var _RecyclerView = require('./RecyclerView');

var _RecyclerView2 = _interopRequireDefault(_RecyclerView);

var _universalEnv = require('universal-env');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SCROLLVIEW_REF = 'scrollview';

var ListView = (_temp2 = _class = function (_Component) {
  _inherits(ListView, _Component);

  function ListView() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ListView);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ListView.__proto__ || Object.getPrototypeOf(ListView)).call.apply(_ref, [this].concat(args))), _this), _this.scrollTo = function (options) {
      if (_this.refs[SCROLLVIEW_REF]) {
        _this.refs[SCROLLVIEW_REF].scrollTo(options);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ListView, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          renderScrollComponent = _props.renderScrollComponent,
          renderHeader = _props.renderHeader,
          renderFooter = _props.renderFooter,
          renderRow = _props.renderRow,
          dataSource = _props.dataSource,
          onEndReached = _props.onEndReached,
          onEndReachedThreshold = _props.onEndReachedThreshold,
          id = _props.id,
          className = _props.className,
          style = _props.style;


      var header = typeof renderHeader == 'function' ? renderHeader() : null;
      var footer = typeof renderFooter == 'function' ? renderFooter() : null;
      var body = dataSource.map(function (i, index) {
        return renderRow(i, index);
      });

      var props = {
        id: id,
        className: className,
        ref: SCROLLVIEW_REF,
        style: style,
        children: [].concat(header, body, footer),
        onEndReached: onEndReached,
        onEndReachedThreshold: onEndReachedThreshold,
        _autoWrapCell: true
      };

      return renderScrollComponent(props);
    }
  }]);

  return ListView;
}(_rax.Component), _class.defaultProps = {
  renderScrollComponent: function renderScrollComponent(props) {
    return (0, _rax.createElement)(_RecyclerView2.default, props);
  },
  dataSource: []
}, _temp2);
exports.default = ListView;