'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp, _class2, _temp2, _class3, _temp4;

var _rax = require('rax');

var _universalEnv = require('universal-env');

var _View = require('./View');

var _View2 = _interopRequireDefault(_View);

var _ScrollView = require('./ScrollView');

var _ScrollView2 = _interopRequireDefault(_ScrollView);

var _RefreshControl = require('./RefreshControl');

var _RefreshControl2 = _interopRequireDefault(_RefreshControl);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DEFAULT_END_REACHED_THRESHOLD = 500;

var Cell = (_temp = _class = function (_PureComponent) {
  _inherits(Cell, _PureComponent);

  function Cell() {
    _classCallCheck(this, Cell);

    return _possibleConstructorReturn(this, (Cell.__proto__ || Object.getPrototypeOf(Cell)).apply(this, arguments));
  }

  _createClass(Cell, [{
    key: 'render',
    value: function render() {
      if (_universalEnv.isWeex && this.context.isInARecyclerView) {
        return (0, _rax.createElement)('cell', _extends({}, this.props, { append: 'tree' }));
      } else {
        return (0, _rax.createElement)(_View2.default, this.props);
      }
    }
  }]);

  return Cell;
}(_rax.PureComponent), _class.contextTypes = {
  isInARecyclerView: _rax.PropTypes.bool
}, _temp);
var Header = (_temp2 = _class2 = function (_PureComponent2) {
  _inherits(Header, _PureComponent2);

  function Header() {
    _classCallCheck(this, Header);

    return _possibleConstructorReturn(this, (Header.__proto__ || Object.getPrototypeOf(Header)).apply(this, arguments));
  }

  _createClass(Header, [{
    key: 'render',
    value: function render() {
      if (_universalEnv.isWeex && this.context.isInARecyclerView) {
        return (0, _rax.createElement)('header', _extends({}, this.props, { append: 'tree' }));
      } else {
        return (0, _rax.createElement)(_View2.default, this.props);
      }
    }
  }]);

  return Header;
}(_rax.PureComponent), _class2.contextTypes = {
  isInARecyclerView: _rax.PropTypes.bool
}, _temp2);
var RecyclerView = (_temp4 = _class3 = function (_Component) {
  _inherits(RecyclerView, _Component);

  function RecyclerView() {
    var _ref;

    var _temp3, _this3, _ret;

    _classCallCheck(this, RecyclerView);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp3 = (_this3 = _possibleConstructorReturn(this, (_ref = RecyclerView.__proto__ || Object.getPrototypeOf(RecyclerView)).call.apply(_ref, [this].concat(args))), _this3), _this3.scrollTo = function (options) {
      var x = parseInt(options.x);
      var y = parseInt(options.y);

      if (_universalEnv.isWeex) {
        var dom = require('@weex-module/dom');
        var firstCell = (0, _rax.findDOMNode)(_this3.refs.cell0);
        dom.scrollToElement(firstCell.ref, {
          offset: x || y || 0
        });
      } else {
        _this3.refs.scrollview.scrollTo(options);
      }
    }, _temp3), _possibleConstructorReturn(_this3, _ret);
  }

  _createClass(RecyclerView, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        isInARecyclerView: true
      };
    }
  }, {
    key: 'render',
    value: function render() {
      var props = this.props;

      if (_universalEnv.isWeex) {
        var children = props.children;
        if (!Array.isArray(children)) {
          children = [children];
        }

        var cells = children.map(function (child, index) {
          if (child) {
            var ref = 'cell' + index;
            if (props._autoWrapCell && child.type != _RefreshControl2.default) {
              return (0, _rax.createElement)(
                Cell,
                { ref: ref },
                child
              );
            } else {
              return (0, _rax.cloneElement)(child, { ref: ref });
            }
          } else {
            return null;
          }
        });

        return (0, _rax.createElement)(
          'list',
          {
            id: props.id,
            style: props.style,
            onLoadmore: props.onEndReached,
            loadmoreoffset: props.onEndReachedThreshold
          },
          cells
        );
      } else {
        return (0, _rax.createElement)(_ScrollView2.default, _extends({}, props, { ref: 'scrollview' }));
      }
    }
  }]);

  return RecyclerView;
}(_rax.Component), _class3.defaultProps = {
  onEndReachedThreshold: DEFAULT_END_REACHED_THRESHOLD
}, _class3.childContextTypes = {
  isInARecyclerView: _rax.PropTypes.bool
}, _temp4);


RecyclerView.Header = Header;
RecyclerView.Cell = Cell;

exports.default = RecyclerView;