'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2;

var _rax = require('rax');

var _universalEnv = require('universal-env');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DEFAULT_WIDTH = '100rem';
var DEFAULT_HEIGHT = '60rem';

var Switch = (_temp2 = _class = function (_Component) {
  _inherits(Switch, _Component);

  function Switch() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Switch);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Switch.__proto__ || Object.getPrototypeOf(Switch)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      value: _this.props.value
    }, _this.handleClick = function (e) {
      if (_this.props.disabled) {
        return null;
      }

      var newVal = !_this.state.value;
      _this.props.onValueChange && _this.props.onValueChange.call(_this, newVal);
      _this.setState({
        value: newVal
      });

      var oldValue = _this.props.value;
      setTimeout(function () {
        if (_this.props.value == oldValue) {
          _this.setState({
            value: _this.props.value
          });
        }
      }, 200);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Switch, [{
    key: 'getStyles',
    value: function getStyles() {
      return {
        span: {
          width: DEFAULT_WIDTH,
          height: DEFAULT_HEIGHT,
          borderRadius: '40rem',
          position: 'relative',
          display: 'inline-block',
          margin: '4rem',
          cursor: 'default', // pointer will cause a grey background color on chrome
          verticalAlign: 'middle',
          borderColor: '#dfdfdf',
          borderWidth: '1px',
          borderStyle: 'solid',
          WebkitUserSelect: 'none',
          WebkitBoxSizing: 'content-box',
          WebkitBackfaceVisibility: 'hidden'
        },
        checkedSpan: {
          borderColor: this.props.onTintColor,
          backgroundColor: this.props.onTintColor,
          boxShadow: this.props.onTintColor + ' 0 0 0 16px inset',
          WebkitTransition: 'border 0.2s, box-shadow 0.2s, background-color 1s'
        },
        uncheckedSpan: {
          borderColor: '#dfdfdf',
          backgroundColor: this.props.tintColor,
          boxShadow: '#dfdfdf 0 0 0 0 inset',
          WebkitTransition: 'border 0.2s, box-shadow 0.2s'
        },
        disabledSpan: {
          opacity: 0.5,
          cursor: 'not-allowed',
          boxShadow: 'none'
        },
        small: {
          position: 'absolute',
          top: 0,
          width: '60rem',
          height: '60rem',
          backgroundColor: this.props.thumbTintColor,
          borderRadius: '100%',
          boxShadow: '0 1px 3px rgba(0,0,0,0.4)',
          WebkitTransition: '-webkit-transform 0.2s ease-in'
        },
        checkedSmall: {
          WebkitTransform: 'translateX(40rem)'
        },
        uncheckedSmall: {
          WebkitTransform: 'translateX(0)'
        }
      };
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      if (_universalEnv.isWeex) {
        var nativeProps = {
          style: _extends({}, styles.initial, this.props.style),
          checked: this.state.value,
          disabled: this.props.disabled,
          onChange: function onChange(_ref2) {
            var value = _ref2.value;
            return _this2.props.onValueChange(value);
          }
        };

        return (0, _rax.createElement)('switch', nativeProps);
      } else {
        var _styles = this.getStyles();
        var spancss = this.state.value ? _extends({}, _styles.span, _styles.checkedSpan) : _extends({}, _styles.span, _styles.uncheckedSpan);
        var smallcss = this.state.value ? _extends({}, _styles.small, _styles.checkedSmall) : _extends({}, _styles.small, _styles.uncheckedSmall);
        spancss = this.props.disabled ? _extends({}, spancss, _styles.disabledSpan) : spancss;

        return (0, _rax.createElement)(
          'span',
          { onClick: this.handleClick, style: spancss },
          (0, _rax.createElement)('small', { style: smallcss })
        );
      }
    }
  }]);

  return Switch;
}(_rax.Component), _class.defaultProps = {
  onTintColor: '#00e158',
  thumbTintColor: '#fff',
  tintColor: '#fff'
}, _temp2);


var styles = {
  initial: {
    width: DEFAULT_WIDTH,
    height: DEFAULT_HEIGHT
  }
};

exports.default = Switch;